Index: /trunk/LMDZ.PLUTO/deftank/callphys.def
===================================================================
--- /trunk/LMDZ.PLUTO/deftank/callphys.def	(revision 3194)
+++ /trunk/LMDZ.PLUTO/deftank/callphys.def	(revision 3195)
@@ -6,5 +6,5 @@
 diurnal   = .true.
 # Seasonal cycle ? if season=false, Ls stays constant, to value set in "start"
-season    = .true. 
+season    = .true.
 # Tidally resonant orbit ? must have diurnal=false, correct rotation rate in newstart
 tlocked   = .false.
@@ -82,10 +82,10 @@
 Fat1AU = 1366.0
 
-## Tracer and aerosol options 
+## Tracer and aerosol options
 ## ~~~~~~~~~~~~~~~~~~~~~~~~~~
 # Gravitational sedimentation of tracers (just H2O ice for now) ?
 sedimentation = .true.
 
-naerkind = 1
+naerkind = 0
 hazeprop = optprop_tholins_fractal100nm.dat
 
@@ -105,6 +105,6 @@
 ## extra non-standard definitions for Earth
 #########################################################################
- 
-## Tracer and aerosol options 
+
+## Tracer and aerosol options
 ## ~~~~~~~~~~~~~~~~~~~~~~~~~~
 # atm mass update due to tracer evaporation/condensation?
@@ -123,5 +123,5 @@
 
 
-## Condensation 
+## Condensation
 ## ~~~~~~~~~~~
 # call N2 condensation ?
Index: /trunk/LMDZ.PLUTO/deftank/traceur.def
===================================================================
--- /trunk/LMDZ.PLUTO/deftank/traceur.def	(revision 3194)
+++ /trunk/LMDZ.PLUTO/deftank/traceur.def	(revision 3195)
@@ -1,2 +1,1 @@
-1
-n2
+0
Index: /trunk/LMDZ.PLUTO/libf/dynphy_lonlat/phypluto/lect_start_archive.F
===================================================================
--- /trunk/LMDZ.PLUTO/libf/dynphy_lonlat/phypluto/lect_start_archive.F	(revision 3194)
+++ /trunk/LMDZ.PLUTO/libf/dynphy_lonlat/phypluto/lect_start_archive.F	(revision 3195)
@@ -7,5 +7,5 @@
 
       USE comsoil_h, ONLY: nsoilmx, layer, mlayer, volcapa, inertiedat
-      USE tracer_h, ONLY: igcm_n2_ice
+      USE tracer_h, ONLY: igcm_haze
       USE infotrac, ONLY: tname, nqtot
 !      USE slab_ice_h, ONLY: noceanmx
@@ -39,5 +39,5 @@
 
 
-c Variables pour les lectures des fichiers "ini" 
+c Variables pour les lectures des fichiers "ini"
 c--------------------------------------------------
 !      INTEGER sizei,
@@ -53,5 +53,5 @@
 !      character (len=50) :: tmpname
 
-c Variable histoire 
+c Variable histoire
 c------------------
       REAL,INTENT(OUT) :: vcov(iip1,jjm,llm),ucov(iip1,jjp1,llm) ! vents covariants
@@ -59,5 +59,5 @@
       REAL,INTENT(OUT) :: q(iip1,jjp1,llm,nqtot)
 
-c Physique sur grille scalaire 
+c Physique sur grille scalaire
 c----------------------------
 
@@ -112,5 +112,5 @@
 
 
-c Variable de l'ancienne grille 
+c Variable de l'ancienne grille
 c---------------------------------------------------------
 
@@ -150,7 +150,7 @@
       logical :: therminertia_3D=.true. ! flag
 ! therminertia_3D=.true. if thermal inertia is 3D and read from datafile
-c Variable intermediaires iutilise pour l'extrapolation verticale 
+c Variable intermediaires iutilise pour l'extrapolation verticale
 c----------------------------------------------------------------
-      real, dimension(:,:,:), allocatable :: var,varp1 
+      real, dimension(:,:,:), allocatable :: var,varp1
       real, dimension(:), allocatable :: oldgrid, oldval
       real, dimension(:), allocatable :: newval
@@ -158,5 +158,5 @@
       real,intent(out) :: surfith(iip1,jjp1) ! surface thermal inertia
       ! surface thermal inertia at old horizontal grid resolution
-      real, dimension(:,:), allocatable :: surfithold 
+      real, dimension(:,:), allocatable :: surfithold
 
       character(len=30) :: txt ! to store some text
@@ -172,5 +172,5 @@
 !-----------------------------------------------------------------------
 
-! 1.2 Read the various dimension lengths of data in file 
+! 1.2 Read the various dimension lengths of data in file
 
       ierr= NF_INQ_DIMID(nid,"Time",dimid)
@@ -245,5 +245,5 @@
 
 ! 1.3 Report dimensions
-      
+
       write(*,*) "Start_archive dimensions:"
       write(*,*) "longitude: ",imold
@@ -259,5 +259,5 @@
       endif
       write(*,*) "time lenght: ",timelen
-      write(*,*) 
+      write(*,*)
 
 !-----------------------------------------------------------------------
@@ -311,5 +311,5 @@
 
 C-----------------------------------------------------------------------
-c 3.1. Lecture du tableau des parametres du run 
+c 3.1. Lecture du tableau des parametres du run
 c     (pour  la lecture ulterieure de "ptotalold" et "n2icetotalold")
 c-----------------------------------------------------------------------
@@ -355,5 +355,5 @@
          PRINT*, "lect_start_archive: Field <rlatu> not found"
          CALL abort
-      ENDIF 
+      ENDIF
 #ifdef NC_DOUBLE
       ierr = NF_GET_VAR_DOUBLE(nid, nvarid, rlatuold)
@@ -440,5 +440,5 @@
 c 3.4 Read Soil layers depths
 c-----------------------------------------------------------------------
-     
+
       ierr=NF_INQ_VARID(nid,"soildepth",nvarid)
       if (ierr.ne.NF_NOERR) then
@@ -540,9 +540,9 @@
       ptotalold = tab_cntrl(tab0+49)
       n2icetotalold = tab_cntrl(tab0+50)
- 
+
 c-----------------------------------------------------------------------
 c 4. Lecture du temps et choix
 c-----------------------------------------------------------------------
- 
+
 c  lecture du temps
 c
@@ -559,5 +559,5 @@
       IF (ierr .NE. NF_NOERR) THEN
          ierr = NF_INQ_VARID (nid, "temps", nvarid)
-      endif 
+      endif
 #ifdef NC_DOUBLE
       ierr = NF_GET_VAR_DOUBLE(nid, nvarid, timelist)
@@ -584,5 +584,5 @@
 
    6  FORMAT(i7,i7,f9.3)
- 
+
       write(*,*)
       write(*,*) 'Choice for the date'
@@ -595,5 +595,5 @@
         endif
       end do
- 
+
       if (memo.eq.0) then
         write(*,*)
@@ -618,8 +618,8 @@
 c 5.1 Lecture des champs 2D (n2ice, emis,ps,tsurf,Tg[10], qsurf)
 c-----------------------------------------------------------------------
- 
+
       start=(/1,1,memo,0/)
       count=(/imold+1,jmold+1,1,0/)
-       
+
       ierr = NF_INQ_VARID (nid, "emis", nvarid)
       IF (ierr .NE. NF_NOERR) THEN
@@ -756,5 +756,5 @@
 !          PRINT*, "lect_start_archive: Failed loading <sea_ice>"
 !       ENDIF
-  
+
 !       ENDIF! ok_slab_ocean
 c
@@ -763,5 +763,5 @@
       write(*,*)
 
-! Surface tracers:      
+! Surface tracers:
       ! initialize all surface tracers to zero
       qsurfold(1:imold+1,1:jmold+1,1:nqtot)=0
@@ -777,5 +777,5 @@
           endif
 
-        
+
         write(*,*) "lect_start_archive: loading tracer ",trim(txt)
         ierr = NF_INQ_VARID (nid,txt,nvarid)
@@ -838,9 +838,9 @@
 c
        enddo ! of do isoil=1,nsoilold
-      
+
       ! reset 'start' and 'count' to "3D" behaviour
       start=(/1,1,1,memo/)
       count=(/imold+1,jmold+1,nsoilold,1/)
-      
+
       else
        write(*,*) "lect_start_archive: loading tsoil "
@@ -856,5 +856,5 @@
 #endif
        endif ! of if (ierr.ne.NF_NOERR)
-       
+
       endif ! of if (olddepthdef)
 
@@ -928,5 +928,5 @@
 c
 
-! Tracers:      
+! Tracers:
       qold(1:imold+1,1:jmold+1,1:lmold,1:nqtot)=0.
 
@@ -1040,6 +1040,6 @@
 c   INTERPOLATION DANS LA NOUVELLE GRILLE et initialisation des variables
 c=======================================================================
-c  Interpolation horizontale puis passage dans la grille physique pour 
-c  les variables physique 
+c  Interpolation horizontale puis passage dans la grille physique pour
+c  les variables physique
 c  Interpolation verticale puis horizontale pour chaque variable 3D
 c=======================================================================
@@ -1048,9 +1048,9 @@
 c 6.1	Variable 2d :
 c-----------------------------------------------------------------------
-c Relief 
+c Relief
       call interp_horiz (phisold,phisold_newgrid,imold,jmold,iim,jjm,1,
      &                   rlonuold,rlatvold,rlonu,rlatv)
 
-! N2 ice is now in qsurf(igcm_n2_ice)
+! N2 ice is now in qsurf(igcm_haze)
 !      call interp_horiz (n2iceold,n2ices,imold,jmold,iim,jjm,1,
 !     &                   rlonuold,rlatvold,rlonu,rlatv)
@@ -1088,4 +1088,5 @@
 c	On assure la conservation de la masse de l'atmosphere + calottes
 c-----------------------------------------------------------------------
+      !AF: TODO: mass conservation: check this. haze?
 
       ptotal =  0.
@@ -1096,8 +1097,8 @@
       END DO
       n2icetotal = 0.
-      if (igcm_n2_ice.ne.0) then
+      if (igcm_haze.ne.0) then
         ! recast surface N2 ice on new grid
-        call interp_horiz(qsurfold(1,1,igcm_n2_ice),
-     &                  qsurfs(1,1,igcm_n2_ice),
+        call interp_horiz(qsurfold(1,1,igcm_haze),
+     &                  qsurfs(1,1,igcm_haze),
      &                  imold,jmold,iim,jjm,1,
      &                  rlonuold,rlatvold,rlonu,rlatv)
@@ -1105,5 +1106,5 @@
          DO i=1,iim
            !n2icetotal = n2icetotal + n2iceS(i,j)*aire(i,j)
-           n2icetotal=n2icetotal+qsurfS(i,j,igcm_n2_ice)*aire(i,j)
+           n2icetotal=n2icetotal+qsurfS(i,j,igcm_haze)*aire(i,j)
          END DO
        END DO
@@ -1115,5 +1116,5 @@
       write(*,*)'Old grid: atmospheric mass :',ptotalold
       write(*,*)'New grid: atmospheric mass :',ptotal
-      write (*,*) 'Ratio new atm./ old atm =', ptotal/ptotalold 
+      write (*,*) 'Ratio new atm./ old atm =', ptotal/ptotalold
       write(*,*)
       write(*,*)'Old grid: mass of N2 ice:',n2icetotalold
@@ -1131,5 +1132,5 @@
       END DO
 
-      if ( n2icetotalold.gt.0.) then 
+      if ( n2icetotalold.gt.0.) then
 !         DO j=1,jjp1
 !            DO i=1,iip1
@@ -1157,5 +1158,5 @@
      &f soil thermal inertia; might be wiser to reset it.'
         write(*,*)
-       
+
         do i=1,imold+1
          do j=1,jmold+1
@@ -1177,9 +1178,9 @@
         ! We have inertiedatold
        if((imold.ne.iim).or.(jmold.ne.jjm)) then
-       write(*,*)'lect_start_archive: WARNING: horizontal interpolation 
+       write(*,*)'lect_start_archive: WARNING: horizontal interpolation
      &of thermal inertia; might be better to reset it.'
        write(*,*)
        endif
-       
+
         ! Do horizontal interpolation
 	if (depthinterpol) then
@@ -1210,5 +1211,5 @@
       call gr_dyn_fi (nsoilmx,iim+1,jjm+1,ngrid,
      &                  inertiedatS,inertiedat)
-      
+
 c-----------------------------------------------------------------------
 c 6.2.2 Soil temperature
@@ -1282,5 +1283,5 @@
 	deallocate(oldval)
 	deallocate(newval)
-       
+
        else
         tsoiloldnew(:,:,:)=tsoilold(:,:,:)
@@ -1303,5 +1304,5 @@
 c 6.4 Variable 3d :
 c-----------------------------------------------------------------------
-      
+
 c temperatures atmospheriques
       write (*,*) 'lect_start_archive: told ', told (1,jmold+1,1)  ! INFO
@@ -1321,5 +1322,5 @@
      &                   rlonuold,rlatvold,rlonu,rlatv)
       call gr_dyn_fi(llm,iim+1,jjm+1,ngrid,du_nonoro_gwdS,du_nonoro_gwd)
-      
+
       call interp_vert
      &    (dv_nonoro_gwdold,var,lmold,llm,apsold,bpsold,aps,bps,
@@ -1328,5 +1329,5 @@
      &                   rlonuold,rlatvold,rlonu,rlatv)
       call gr_dyn_fi(llm,iim+1,jjm+1,ngrid,dv_nonoro_gwdS,dv_nonoro_gwd)
-      
+
       call interp_vert
      &    (east_gwstressold,var,lmold,llm,apsold,bpsold,aps,bps,
@@ -1335,5 +1336,5 @@
      &                   rlonuold,rlatvold,rlonu,rlatv)
       call gr_dyn_fi(llm,iim+1,jjm+1,ngrid,east_gwstressS,east_gwstress)
-      
+
       call interp_vert
      &    (west_gwstressold,var,lmold,llm,apsold,bpsold,aps,bps,
@@ -1379,5 +1380,5 @@
           end do
         end do
-      end do 
+      end do
       write (*,*) 'lect_start_archive: ucov ', ucov (1,2,1)  ! INFO
 c     write(48,*) 'ucov',ucov
@@ -1410,10 +1411,10 @@
      &                  rlonuold,rlatvold,rlonu,rlatv)
       enddo
-cccccccccccccccccccccccccccccc      
-c  make sure that sum of q = 1      
-c dominent species is = 1 - sum(all other species)      
-cccccccccccccccccccccccccccccc      
+cccccccccccccccccccccccccccccc
+c  make sure that sum of q = 1
+c dominent species is = 1 - sum(all other species)
+cccccccccccccccccccccccccccccc
 c      iqmax=1
-c      
+c
 c      if (nqold.gt.10) then
 c       do l=1,llm
@@ -1428,6 +1429,6 @@
 c           qtot(i,j,l)=0
 c           do iq=1,nqold
-c            if (iq.ne.iqmax) then        
-c              q(i,j,l,iqmax)=q(i,j,l,iqmax)-q(i,j,l,iq)        
+c            if (iq.ne.iqmax) then
+c              q(i,j,l,iqmax)=q(i,j,l,iqmax)-q(i,j,l,iq)
 c            endif
 c           enddo !iq
@@ -1437,7 +1438,7 @@
 c     $    qtot(i,j,l)
 c           enddo !iq
-c          enddo !i   
-c         enddo !j   
-c       enddo !l  
+c          enddo !i
+c         enddo !j
+c       enddo !l
 c      endif
 ccccccccccccccccccccccccccccccc
@@ -1451,7 +1452,7 @@
          end do
       enddo
-      
+
 !      call gr_dyn_fi (1,iim+1,jjm+1,ngrid,n2ices,n2ice)
-! no need to transfer "n2ice" any more; it is in qsurf(igcm_n2_ice)
+! no need to transfer "n2ice" any more; it is in qsurf(igcm_haze)
 
       endif !! if nqtot .ne. 0
Index: /trunk/LMDZ.PLUTO/libf/phypluto/aeropacity.F90
===================================================================
--- /trunk/LMDZ.PLUTO/libf/phypluto/aeropacity.F90	(revision 3194)
+++ /trunk/LMDZ.PLUTO/libf/phypluto/aeropacity.F90	(revision 3195)
@@ -10,17 +10,13 @@
 
        use radinc_h, only : L_TAUMAX,naerkind
-       use aerosol_mod, only: iaero_nlay, iaero_generic, &
-                              iaero_aurora, iaero_back2lay, iaero_n2, &
-                              iaero_dust, iaero_h2so4, &
-                              iaero_nh3, i_rgcs_ice, noaero
+       use aerosol_mod, only: iaero_haze, i_haze, iaero_generic, &
+                              noaero
        USE tracer_h, only: noms,rho_n2,rho_ice,rho_q,mmol
        use comcstfi_mod, only: g, pi, mugaz, avocado
        use geometry_mod, only: latitude
        use callkeys_mod, only: aerofixn2,kastprof,cloudlvl,	&
-		dusttau,			 	&
 		pres_bottom_tropo,pres_top_tropo,obs_tau_col_tropo,	&
 		pres_bottom_strato,pres_top_strato,obs_tau_col_strato,  &
-                tau_nh3_cloud, pres_nh3_cloud,                          &
-                nlayaero, aeronlay_tauref, aeronlay_choice,             & 
+                nlayaero, aeronlay_tauref, aeronlay_choice,             &
                 aeronlay_pbot, aeronlay_ptop, aeronlay_sclhght,         &
                 aerogeneric
@@ -29,13 +25,13 @@
 
 !==================================================================
-!     
+!
 !     Purpose
 !     -------
 !     Compute aerosol optical depth in each gridbox.
-!     
+!
 !     Authors
-!     ------- 
+!     -------
 !     F. Forget
-!     F. Montmessin (water ice scheme) 
+!     F. Montmessin (water ice scheme)
 !     update J.-B. Madeleine (2008)
 !     dust removal, simplification by Robin Wordsworth (2009)
@@ -44,5 +40,5 @@
 !
 !     Input
-!     ----- 
+!     -----
 !     ngrid             Number of horizontal gridpoints
 !     nlayer            Number of layers
@@ -97,9 +93,4 @@
       CHARACTER(LEN=20) :: tracername ! to temporarily store text
 
-      ! for fixed dust profiles
-      real topdust, expfactor, zp
-      REAL taudusttmp(ngrid) ! Temporary dust opacity used before scaling
-      REAL tauh2so4tmp(ngrid) ! Temporary h2so4 opacity used before scaling
-
       real CLFtot
       integer igen_ice,igen_vap ! to store the index of generic tracer
@@ -131,28 +122,4 @@
         endif
 
-        if ((iaero_n2.ne.0).and.(.not.noaero)) then
-          print*, 'iaero_n2=  ',iaero_n2
-        endif
-        if (iaero_dust.ne.0) then
-          print*,'iaero_dust= ',iaero_dust
-        endif
-        if (iaero_h2so4.ne.0) then
-          print*,'iaero_h2so4= ',iaero_h2so4
-        endif
-        if (iaero_back2lay.ne.0) then
-          print*,'iaero_back2lay= ',iaero_back2lay
-        endif
-        if (iaero_nh3.ne.0) then
-          print*,'iaero_nh3= ',iaero_nh3
-        endif
-        if (iaero_nlay(1).ne.0) then
-          print*,'iaero_nlay= ',iaero_nlay(:)
-        endif
-        if (iaero_aurora.ne.0) then
-          print*,'iaero_aurora= ',iaero_aurora
-        endif
-        if (aerogeneric .ne. 0) then 
-          print*,"iaero_generic= ",iaero_generic(:)
-        endif
         firstcall=.false.
       ENDIF ! of IF (firstcall)
@@ -161,274 +128,68 @@
 !     ---------------------------------------------------------
 !==================================================================
-!    N2 ice aerosols
+!    Haze aerosols
 !==================================================================
 
-      if (iaero_n2.ne.0) then
-           iaer=iaero_n2
+      if (iaero_haze.ne.0) then
+        iaer=iaero_haze
 !       1. Initialization
-            aerosol(1:ngrid,1:nlayer,iaer)=0.0
+         aerosol(1:ngrid,1:nlayer,iaer)=0.0
 !       2. Opacity calculation
-            if (noaero) then ! aerosol set to zero
-             aerosol(1:ngrid,1:nlayer,iaer)=0.0
-            elseif (aerofixn2.or.(i_n2ice.eq.0)) then !  N2 ice cloud prescribed
-               aerosol(1:ngrid,1:nlayer,iaer)=1.e-9
-               !aerosol(1:ngrid,12,iaer)=4.0 ! single cloud layer option
-            else
-               DO ig=1, ngrid
-                  DO l=1,nlayer-1 ! to stop the rad tran bug
-
-                     aerosol0 =                         &
-                          (  0.75 * QREFvis3d(ig,l,iaer) /        &
-                          ( rho_n2 * reffrad(ig,l,iaer) )  ) *   &
-                          ( pq(ig,l,i_n2ice) + 1.E-9 ) *         &
-                          ( pplev(ig,l) - pplev(ig,l+1) ) / g
-                     aerosol0           = max(aerosol0,1.e-9)
-                     aerosol0           = min(aerosol0,L_TAUMAX)
-                     aerosol(ig,l,iaer) = aerosol0
-!                     aerosol(ig,l,iaer) = 0.0
-!                     print*, aerosol(ig,l,iaer)
-!        using cloud fraction
-!                     aerosol(ig,l,iaer) = -log(1 - CLF + CLF*exp(-aerosol0/CLF))
-!                     aerosol(ig,l,iaer) = min(aerosol(ig,l,iaer),L_TAUMAX)
-
-
-                  ENDDO
+         DO ig=1, ngrid
+               DO l=1,nlayer-1 ! to stop the rad tran bug
+                  ! if fractal, radius doit etre equivalent sphere radius
+                  aerosol0 =                         &
+                       (  0.75 * QREFvis3d(ig,l,iaer) /        &
+                       ( rho_q(i_haze) * reffrad(ig,l,iaer) )  ) *   &
+                       ( pq(ig,l,i_haze) + 1.E-10 ) *         &
+                       ( pplev(ig,l) - pplev(ig,l+1) ) / g
+                  aerosol0           = max(aerosol0,1.e-10)
+                  aerosol0           = min(aerosol0,L_TAUMAX)
+                  aerosol(ig,l,iaer) = aerosol0
                ENDDO
-            end if ! if fixed or varying
-      end if ! if N2 aerosols   
-!==================================================================
-!     Water ice / liquid (AF24: removed)
-!==================================================================
-
-!==================================================================
-!             Dust (AF24: removed)
-!==================================================================
-
-!==================================================================
-!           H2SO4 (AF24: removed)
-!==================================================================
-!==================================================================
-!    Two-layer aerosols (unknown composition)
-!    S. Guerlet (2013) - Modif by J. Vatant d'Ollone (2020)
-!    
-!    This scheme is deprecated and left for retrocompatibility
-!    You should use the n-layer scheme below !
-!
-!==================================================================
-
-!==================================================================
-!    Saturn/Jupiter ammonia cloud = thin cloud (scale height 0.2 hard coded...)
-!    S. Guerlet (2013)
-!    JVO 20 : You should now use the generic n-layer scheme below
-!==================================================================
-
-!=========================================================================================================
-!    Generic N-layers aerosols/clouds
-!    Author : J. Vatant d'Ollone (2020)
-!    
-!    Purpose: Replaces and extents the former buggy 2-layer scheme as well as hard-coded NH3 cloud
-!    
-!    + Each layer can have different optical properties, size of particle ...
-!    + Enables up to n=4 layers as we apparently cannot run with more scatterers (could be worth checking...)
-!    + You have different choices for vertical profile of the aerosol layers :
-!           * aeronlay_choice = 1 : Layer tau is spread between ptop and pbot following atm scale height.
-!           * aeronlay_choice = 2 : Layer tau follows its own scale height above cloud deck (pbot).
-!                                   In this case ptop is dummy and sclhght gives the ratio H_cl/H_atm.
-!           * aeronlay_choice = ... feel free to add more cases  !
-!    + Layers can overlap if needed (if you want a 'transition layer' as in the 2-scheme, just add it)
-!
-!=========================================================================================================
-
-      if (iaero_nlay(1) .ne.0) then
-
-        DO ia=1,nlayaero
-           iaer=iaero_nlay(ia)
-
-!          a. Initialization
-           aerosol(1:ngrid,1:nlayer,iaer)=0.D0
-
-!          b. Opacity calculation
-           
-           ! Case 1 : Follows atmospheric scale height between boundaries pressures
-           ! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-           IF (aeronlay_choice(ia).eq.1) THEN
-
-             dp_layer(:)=0.D0
-             DO ig=1,ngrid
-               DO l=1,nlayer-1
-                 !! i. Opacity follows scale height
-                 IF ( pplev(ig,l).le.aeronlay_pbot(ia)   .AND.          &
-                      pplev(ig,l).ge.aeronlay_ptop(ia) ) THEN
-                   aerosol(ig,l,iaer) = ( pplev(ig,l) - pplev(ig,l+1) )
-                   dp_layer(ig) = dp_layer(ig) + aerosol(ig,l,iaer)
-                 !! ii. Outside aerosol layer boundaries: no aerosols
-                 ELSE
-                   aerosol(ig,l,iaer) = 0.D0
-                 ENDIF
-               ENDDO
-             ENDDO
-             ! iii. Re-normalize to required total opacity
-             DO ig=1,ngrid
-               DO l=1,nlayer-1
-                 IF ( pplev(ig,l).le.aeronlay_pbot(ia)   .AND.          &
-                      pplev(ig,l).ge.aeronlay_ptop(ia) ) THEN
-                  aerosol(ig,l,iaer) = aerosol(ig,l,iaer) / dp_layer(ig) &
-                                     * aeronlay_tauref(ia)
-                 ENDIF
-               ENDDO
-             ENDDO
-
-           ! Case 2 : Follows input scale height
-           ! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-           ELSE IF (aeronlay_choice(ia).eq.2) THEN
-           
-             cloud_slope  = 1.D0/aeronlay_sclhght(ia)
-             pcloud_deck  = aeronlay_pbot(ia)
-             dp_layer(:)  = 0.D0
-
-             DO ig=1,ngrid
-               DO l=1,nlayer-1
-                 !! i. Below cloud layer: no opacity
-                 IF (pplev(ig,l) .gt. pcloud_deck) THEN
-                   aerosol(ig,l,iaer) = 0.D0            
-                 !! ii. Follows scale height above cloud deck
-                 ELSEIF (pplev(ig,l) .le. pcloud_deck) THEN 
-                   aerosol(ig,l,iaer) = ((pplev(ig,l)/pcloud_deck)**(cloud_slope))
-                   dp_layer(ig) = dp_layer(ig) + aerosol(ig,l,iaer)
-                 ENDIF
-               ENDDO
-             ENDDO
-             ! iii. Re-normalize to required total opacity
-             DO ig=1,ngrid
-               DO l=1,nlayer-1
-                 IF (pplev(ig,l) .le. pcloud_deck) THEN 
-                  aerosol(ig,l,iaer) = aerosol(ig,l,iaer) / dp_layer(ig) &
-                                     * aeronlay_tauref(ia)
-                 ENDIF
-               ENDDO
-             ENDDO
-
-           ENDIF ! aeronlay_choice
-
-          ENDDO ! loop on n aerosol layers
-
-      end if ! if N-layer aerosols
-  
-!==================================================================
-!    Jovian auroral aerosols (unknown composition) NON-GENERIC: vertical and meridional profile tuned to observations
-!    S. Guerlet (2015)
-!==================================================================
-
-
-      if (iaero_aurora .ne.0) then
-           iaer=iaero_aurora
-!       1. Initialization
-            aerosol(1:ngrid,1:nlayer,iaer)=0.D0 
-	 pm = 2000. !!case study: maxi aerosols at 20 hPa
-!       2. Opacity calculation
-          DO ig=1,ngrid
-
-	  !! Test Jupiter (based on Zhang et al 2013 observations, but a bit different), decembre 2015
-              DO l=1,nlayer
-       		aerosol(ig,l,iaer) = (pplev(ig,l)/pm)**2 * exp(-(pplev(ig,l)/pm)**2)
-              ENDDO
-          ENDDO
-	 
- !       3. Meridional distribution, and re-normalize to observed total column
-         dp_layer(:)=0.D0
-         DO ig=1,ngrid
-	  !!Jupiter
-	  !!Hem sud:
-          IF (latitude(ig)*180.D0/pi .lt. -45.D0 .and. latitude(ig)*180.D0/pi .gt. -70.) THEN
- 	  obs_tau_col_aurora= 10.D0**(-0.06D0*latitude(ig)*180.D0/pi-3.4D0) 
-          ELSEIF (latitude(ig)*180.D0/pi .lt. -37.D0 .and. latitude(ig)*180.D0/pi .ge. -45.) THEN
- 	  obs_tau_col_aurora= 10.D0**(-0.3D0*latitude(ig)*180.D0/pi-14.3D0) 
-           ELSEIF (latitude(ig)*180./pi .le. -70. ) THEN
- 	  obs_tau_col_aurora= 10**(0.06*70.-3.4D0) 
-	  !!Hem Nord:  
-          ELSEIF (latitude(ig)*180.D0/pi .gt. 30.D0 .and. latitude(ig)*180.D0/pi .lt. 70.) THEN
-	  obs_tau_col_aurora= 10.D0**(0.03D0*latitude(ig)*180.D0/pi-1.17D0)  
-          ELSEIF (latitude(ig)*180.D0/pi .gt. 22.D0 .and. latitude(ig)*180.D0/pi .le. 30.) THEN
-	  obs_tau_col_aurora= 10.D0**(0.3D0*latitude(ig)*180.D0/pi-9.4D0)  
-          ELSEIF (latitude(ig)*180.D0/pi .ge. 70.) THEN
-	  obs_tau_col_aurora= 10**(0.03*70.-1.17D0)  
-          ELSEIF (latitude(ig)*180.D0/pi .ge. -37. .and. latitude(ig)*180.D0/pi .le. 22.) THEN
-	 obs_tau_col_aurora = 0.001D0    !!Jupiter: mini pas a zero
-	  ENDIF
-
- 	  DO l=1,nlayer  
-               dp_layer(ig) = dp_layer(ig) + aerosol(ig,l,iaer)/obs_tau_col_aurora
-          ENDDO
          ENDDO
-
-         DO ig=1,ngrid
-           DO l=1,nlayer-1
-                aerosol(ig,l,iaer)=aerosol(ig,l,iaer)/dp_layer(ig)
-           ENDDO
-         ENDDO
-
-
-      end if ! if Auroral aerosols  
-!===========================================================================
-!    Radiative Generic Condensable aerosols scheme
-!    Only used when we give aerogeneric != 0 in callphys.def
-!    Computes the generic aerosols' opacity in the same fashion as water of 
-!    dust, using the QREFvis3d of the concerned specie
-!    Lucas Teinturier (2022)
-!===========================================================================
-      if (aerogeneric .ne. 0) then ! we enter the scheme
-        do ia=1,aerogeneric
-          iaer = iaero_generic(ia)
-          ! Initialization
-          aerosol(1:ngrid,1:nlayer,iaer) = 0.D0
-          igen_ice = i_rgcs_ice(ia)
-          ! Let's loop on the horizontal and vertical grid
-          do ig=1,ngrid
-            do l=1,nlayer
-              aerosol(ig,l,iaer) = ( 0.75*QREFvis3d(ig,l,iaer)  / &
-                                  (rho_q(igen_ice) * reffrad(ig,l,iaer)) ) * &
-                                  (pq(ig,l,igen_ice)+1E-9 ) *                &
-                                  (pplev(ig,l) - pplev(ig,l+1)) /g 
-            enddo !l=1,nlayer
-          enddo !ig=1,ngrid
-        enddo !ia=1,aerogeneric
-      endif !aerogeneric .ne. 0
+         !QREF est le meme dans toute la colonne par def si size uniforme
+         !print*, 'TB17: QREFvis3d=',QREFvis3d(1,:,1)
+         !print*, 'TB17: rho_q=',rho_q(i_haze)
+         !print*, 'TB17: reffrad=',reffrad(1,:,1)
+         !print*, 'TB17: pq=',pq(1,:,i_haze)
+         !print*, 'TB17: deltap=',pplev(1,1) - pplev(1,nlayer)
+   end if ! if haze aerosols
 
 ! --------------------------------------------------------------------------
 ! Column integrated visible optical depth in each point (used for diagnostic)
 
-      tau_col(:)=0.0
-      do iaer = 1, naerkind
-         do l=1,nlayer
-            do ig=1,ngrid
-               tau_col(ig) = tau_col(ig) + aerosol(ig,l,iaer)
-            end do
+   tau_col(:)=0.0
+   do iaer = 1, naerkind
+      do l=1,nlayer
+         do ig=1,ngrid
+            tau_col(ig) = tau_col(ig) + aerosol(ig,l,iaer)
          end do
       end do
+   end do
 
-      ! do ig=1,ngrid
-      !    do l=1,nlayer
-      !       do iaer = 1, naerkind
-      !          if(aerosol(ig,l,iaer).gt.1.e3)then
-      !             print*,'WARNING: aerosol=',aerosol(ig,l,iaer)
-      !             print*,'at ig=',ig,',  l=',l,', iaer=',iaer
-      !             print*,'QREFvis3d=',QREFvis3d(ig,l,iaer)
-      !             print*,'reffrad=',reffrad(ig,l,iaer)
-      !          endif
-      !       end do
-      !    end do
-      ! end do
+   do ig=1,ngrid
+      do l=1,nlayer
+         do iaer = 1, naerkind
+            if(aerosol(ig,l,iaer).gt.1.e3)then
+               print*,'WARNING: aerosol=',aerosol(ig,l,iaer)
+               print*,'at ig=',ig,',  l=',l,', iaer=',iaer
+               print*,'QREFvis3d=',QREFvis3d(ig,l,iaer)
+               print*,'reffrad=',reffrad(ig,l,iaer)
+            endif
+         end do
+      end do
+   end do
 
-      ! do ig=1,ngrid
-      !    if(tau_col(ig).gt.1.e3)then
-      !       print*,'WARNING: tau_col=',tau_col(ig)
-      !       print*,'at ig=',ig
-      !       print*,'aerosol=',aerosol(ig,:,:)
-      !       print*,'QREFvis3d=',QREFvis3d(ig,:,:)
-      !       print*,'reffrad=',reffrad(ig,:,:)
-      !    endif
-      ! end do
+   do ig=1,ngrid
+      if(tau_col(ig).gt.1.e3)then
+         print*,'WARNING: tau_col=',tau_col(ig)
+         print*,'at ig=',ig
+         print*,'aerosol=',aerosol(ig,:,:)
+         print*,'QREFvis3d=',QREFvis3d(ig,:,:)
+         print*,'reffrad=',reffrad(ig,:,:)
+      endif
+   end do
+  end subroutine aeropacity
 
-    end subroutine aeropacity
-      
 end module aeropacity_mod
